(* Inductive definitions. *)
open Lf

type constructor = string * t (* name * type *)

type inductive = string * t * constructor list (* name * arity * constructors *)

let rec arity =
  function
    | Prod(x,body) -> x :: (arity body)
    | _ -> []
	
let rec is_valid_type =
  function
    | Type -> true
    | Prod(_, body) -> is_valid_type body
    | _ -> false

let rec is_valid_domain context inductive_typename arity domain =
  match domain, arity with
    | (Var x, []) ->
	x = inductive_typename
    | (App(dom,arg), typ :: domtype) ->
	let arg = normalize_cbn context arg in
	let typ = normalize_cbn context typ in
	  (arg = typ) && (is_valid_domain context inductive_typename domtype dom)
    | _ -> false

let rec strictly_positive (indname,indtype,indcons) term =
  match term with
    | Kind -> false
    | Type -> ???
    | Var x ->
	
	
let rec constructor_type_wf ((indname,indtype,indcons) as inddef) term =
  match term with
    | Kind
    | Type -> false
    | Var x ->
	if x = indname then
	  (arity indtype) = []
	else
	  false
    | Prod(typ,codom) ->
	(strictly_positive inddef typ) && (constructor_type_wf codom)
    | App(_, _) ->
	is_valid_domain context inductive_typename (arity indtype) term
    | _ -> false
