type var = string

type t =
  | Kind
  | Type
(*  | Var  of var *)
  | Prod of t * (t -> t)
  | Lam  of t * (t -> t)
  | App  of t * t

type context = (var * t) list

(* let genfresh fresh = *)
(*   ("v"^(string_of_int fresh), fresh+1) *)

(* let rec alpha fresh gamma t = *)
(*   match t with *)
(*   | Kind | Type -> t, fresh *)
(*   | Var v -> *)
(*       if List.mem_assoc v gamma then *)
(* 	(Var (List.assoc v gamma)), fresh *)
(*       else *)
(* 	t, fresh *)
(*   | Prod(var, t0, t1) -> *)
(*       let v, fresh = genfresh fresh in *)
(*       let t0', fresh = alpha fresh gamma t0 in *)
(*       let t1', fresh = alpha fresh ((var, v) :: gamma) t1 in *)
(*       Prod(v, t0', t1'), fresh *)
(*   | Lam(var, t0, t1) -> *)
(*       let v, fresh = genfresh fresh in *)
(*       let t0', fresh = alpha fresh gamma t0 in *)
(*       let t1', fresh = alpha fresh ((var, v) :: gamma) t1 in *)
(*       Lam(v, t0', t1') *)
(*   | App(t0, t1) -> *)
(*       let t0', fresh = alpha fresh gamma t0 in *)
(*       let t1', fresh = alpha fresh gamma t1 in *)
(*       App(t0, t1) *)

(* let rec nf gamma t = *)
(*   match t with *)
(*   | Kind | Type -> t *)
(*   | Var v -> *)
(*       if List.mem_assoc v gamma then *)
(* 	List.assoc v gamma *)

(* let rec subst var t' t = *)
(*   match t with *)
(*   | Var v -> *)
(*       if v = var then *)
(* 	t' *)
(*       else *)
(* 	t *)
(*   | Prod(v, t0, t1) -> *)
(*       if var = v then *)
(* 	t *)
(*       else *)
(* 	Prod(var, subst var t' t0, subst var t' t1) *)
(*   | Lam(v, t0, t1) -> *)
(*       if var = v then *)
(* 	t *)
(*       else *)
(* 	Lam(var, subst var t' t0, subst var t' t1) *)
(*   | App(func, arg) -> *)
(*       App(subst var t' func, subst var t' arg) *)
(*   | _ -> t *)

let rec context_wf =
  function
  | [] -> true
  | (x, typ) :: gamma ->
      begin match typ with
      | Kind
      | Type ->
	  (typegen gamma typ = Kind)
	  || (typegen gamma typ = Type)
      | _ ->
	  context_wf gamma (* WTF *)
      end

and typegen gamma term =
  match term with
  | Kind -> failwith "no type for Kind"
  | Type -> Kind
  | Var v ->
      if List.mem_assoc v gamma then
	if context_wf gamma then
	  List.assoc v gamma
	else
	  failwith "ill-formed context"
      else
	failwith ("variable "^v^" not found in context")
  | Prod(var, vartype, body) ->
      let body_type = typegen ((var, vartype) :: gamma) body in
      if typegen gamma vartype = Type then
	body_type
      else
	failwith ("quantified variable "^var^" is not of type Type in product")
  | App(abstr, arg) ->
      (match typegen gamma abstr with
       | Prod(var, vartype, body) ->
	   if (typegen gamma arg) = vartype then
	     subst var arg body
	   else
	     failwith "argument type does not match product parameter"
       | _ ->
	   failwith "function has not a product type")
  | Lam(arg, argtype, body) ->
      if (typegen gamma argtype) = Type then
	let body_type = typegen ((arg, argtype) :: gamma) body in
	match typegen ((arg, argtype) :: gamma) body_type with
	| Type | Kind ->
	    Prod(arg, argtype, body_type)
	| _ ->
	    failwith "abstraction body's type is not of type Type nor Kind"
      else
	failwith "abstraction parameter's type is not of type Type"

(* type var = string *)

(* type t = *)
(*   | Kind *)
(*   | Type *)
(*   | Var  of var *)
(*   | Prod of var * t * t *)
(*   | Lam  of var * t * t *)
(*   | App  of t * t *)

(* type context = (var * t) list *)

(* let genfresh fresh = *)
(*   ("v"^(string_of_int fresh), fresh+1) *)

(* let rec alpha fresh gamma t = *)
(*   match t with *)
(*   | Kind | Type -> t, fresh *)
(*   | Var v -> *)
(*       if List.mem_assoc v gamma then *)
(* 	(Var (List.assoc v gamma)), fresh *)
(*       else *)
(* 	t, fresh *)
(*   | Prod(var, t0, t1) -> *)
(*       let v, fresh = genfresh fresh in *)
(*       let t0', fresh = alpha fresh gamma t0 in *)
(*       let t1', fresh = alpha fresh ((var, v) :: gamma) t1 in *)
(*       Prod(v, t0', t1'), fresh *)
(*   | Lam(var, t0, t1) -> *)
(*       let v, fresh = genfresh fresh in *)
(*       let t0', fresh = alpha fresh gamma t0 in *)
(*       let t1', fresh = alpha fresh ((var, v) :: gamma) t1 in *)
(*       Lam(v, t0', t1') *)
(*   | App(t0, t1) -> *)
(*       let t0', fresh = alpha fresh gamma t0 in *)
(*       let t1', fresh = alpha fresh gamma t1 in *)
(*       App(t0, t1) *)

(* let rec nf gamma t = *)
(*   match t with *)
(*   | Kind | Type -> t *)
(*   | Var v -> *)
(*       if List.mem_assoc v gamma then *)
(* 	List.assoc v gamma *)

(* let rec subst var t' t = *)
(*   match t with *)
(*   | Var v -> *)
(*       if v = var then *)
(* 	t' *)
(*       else *)
(* 	t *)
(*   | Prod(v, t0, t1) -> *)
(*       if var = v then *)
(* 	t *)
(*       else *)
(* 	Prod(var, subst var t' t0, subst var t' t1) *)
(*   | Lam(v, t0, t1) -> *)
(*       if var = v then *)
(* 	t *)
(*       else *)
(* 	Lam(var, subst var t' t0, subst var t' t1) *)
(*   | App(func, arg) -> *)
(*       App(subst var t' func, subst var t' arg) *)
(*   | _ -> t *)

(* let rec context_wf = *)
(*   function *)
(*   | [] -> true *)
(*   | (x, typ) :: gamma -> *)
(*       begin match typ with *)
(*       | Kind *)
(*       | Type -> *)
(* 	  (typegen gamma typ = Kind) *)
(* 	  || (typegen gamma typ = Type) *)
(*       | _ -> *)
(* 	  context_wf gamma (\* WTF *\) *)
(*       end *)

(* and typegen gamma term = *)
(*   match term with *)
(*   | Kind -> failwith "no type for Kind" *)
(*   | Type -> Kind *)
(*   | Var v -> *)
(*       if List.mem_assoc v gamma then *)
(* 	if context_wf gamma then *)
(* 	  List.assoc v gamma *)
(* 	else *)
(* 	  failwith "ill-formed context" *)
(*       else *)
(* 	failwith ("variable "^v^" not found in context") *)
(*   | Prod(var, vartype, body) -> *)
(*       let body_type = typegen ((var, vartype) :: gamma) body in *)
(*       if typegen gamma vartype = Type then *)
(* 	body_type *)
(*       else *)
(* 	failwith ("quantified variable "^var^" is not of type Type in product") *)
(*   | App(abstr, arg) -> *)
(*       (match typegen gamma abstr with *)
(*        | Prod(var, vartype, body) -> *)
(* 	   if (typegen gamma arg) = vartype then *)
(* 	     subst var arg body *)
(* 	   else *)
(* 	     failwith "argument type does not match product parameter" *)
(*        | _ -> *)
(* 	   failwith "function has not a product type") *)
(*   | Lam(arg, argtype, body) -> *)
(*       if (typegen gamma argtype) = Type then *)
(* 	let body_type = typegen ((arg, argtype) :: gamma) body in *)
(* 	match typegen ((arg, argtype) :: gamma) body_type with *)
(* 	| Type | Kind -> *)
(* 	    Prod(arg, argtype, body_type) *)
(* 	| _ -> *)
(* 	    failwith "abstraction body's type is not of type Type nor Kind" *)
(*       else *)
(* 	failwith "abstraction parameter's type is not of type Type" *)
