{
  open Parser
}

let digit = ['0'-'9']
let letter = ['a'-'z'] | ['A'-'Z']
let upper_case_letter = ['A'-'Z']
let lower_case_letter = ['a'-'z']

rule token = parse
  | [' ' '\t'] { token lexbuf }
(*  | digit+ as num { INTEGER(num) }*)
  | "." digit+
(*  | digit+ "." digit* as num
      { FLOAT (num) }*)
  | "let" { LET }
  | "in" { IN }
  | "+"  { PLUS }
  | "fun" { FUNCTION }
  | "forall" { FORALL }
  | "exists" { EXISTS }
  | "proj1" { PRJ1 }
  | "proj2" { PRJ2 }
  | "inj1" { INJ1 }
  | "inj2" { INJ2 }
  | "case" { CASE }
  | "refl" { REFL }
  | "subst" { SUBST }
  | "|" { PIPE }
  | ":=" { ASSIGN }
  | "=" { EQUAL }
  | "(" { OPENP }
  | ")" { CLOSEP }
  | ',' { COMMA }
  | '.' { DOT }
  | ':' { COLON }
  | "=>" { FUNARROW }
  | "->" { ARROW }
  | "Type" { TYPE }
  | "Kind" { KIND }
  | "Constant" { CONSTANT }
  | "Define" { DEFINE }
  | (upper_case_letter | '_')(letter | digit | '_' | '\'')*  as id { CONSTRUCTOR(id) }
  | (lower_case_letter | '_')(letter | digit | '_' | '\'')*  as id { IDENT(id) }
  | _ { token lexbuf }
  | eof { EOF }
